'use strict';

var util = require( 'util' );
var originalLog = console.log;
var prefix = '';

function format ( args ) {
	return util.format.apply( null, args ).replace( /^/gm, prefix );
}

function consoleLog () {
	this._stdout.write( format( arguments ) + '\n' );
}

function consoleGroup () {
	prefix += '⎢ ';
	this._stdout.write( '\u001b[1m' + format( arguments ) + '\u001b[22m\n' );
}

function consoleGroupEnd () {
	prefix = prefix.slice( 0, -2 );
	console.log( '⎣' );
}

function install () {
	console.log = consoleLog;
	console.group = consoleGroup;
	console.groupEnd = consoleGroupEnd;
}

function teardown () {
	console.log = originalLog;
	delete console.group;
	delete console.groupEnd;
}

exports.install = install;
exports.teardown = teardown;